<?php

function readConfig( $path ) {
	$file = file( $path );
	array_shift( $file );
	array_pop( $file );
	$config = array();
	foreach( $file as $number => $line ) {
		if( trim($line) && substr($line, 0, 1) != ';' ) {
			$directive = explode( '=', $line );
			$field = trim( $directive[0] );
			$value = trim( str_replace( '"', '', $directive[1]) );
			$config[$field] = $value;
		}
	}
	return $config;
}

function decodeNumberList( $list ){
	$arr = explode( 'z', $list );
	$result = array();
	foreach( $arr as $item ){
		$result[] = base_convert( $item, 35, 10 );
	}
	return implode( ',', $result );
}


/*** Do some initialisation ***/

if( !ini_get('safe_mode') ){
	set_time_limit(0);
}

$ziplifetime = 3 * 60 * 60; // after this number of seconds a zip file will be deleted
$zipfilename = 'bilder.zip';

$my_dir = explode( '/', dirname(__FILE__) );
array_splice( $my_dir, -3 );
$pxtc_dir = implode( '/', $my_dir );
unset( $my_dir );

$conf = readConfig( $pxtc_dir . '/config/config.php' );

$cmd = isset( $conf['pathToZipCommand'] ) ? $conf['pathToZipCommand'] : '/usr/bin/zip';

if( ! isset( $conf['baseURL'] ) ) {
	if( isset( $_SERVER['HTTPS'] ) && $_SERVER['HTTPS'] == "on") {
		$conf['baseURL'] = 'https://';
	} else {
		$conf['baseURL'] = 'http://';
	}
	$conf['baseURL'] .= rtrim( $_SERVER['HTTP_HOST'], '/' );
	$arr = explode( '/', dirname( $_SERVER['PHP_SELF'] ) );
	$arr = array_splice( $arr, 0, -3 );
	$conf['baseURL'] .= str_replace( '//', '/', implode( '/', $arr ) . '/' );
	unset( $arr );
}


/*** Create temp directory, if neccessary ***/

if( isset( $conf['pathToTemp'] ) && file_exists( $conf['pathToTemp'] ) ){
	$tempdir = $conf['pathToTemp'];
	$tempurl = $conf['baseURLTemp'];
} else {
	$tempdir = $pxtc_dir . '/data/temp';
	if( !file_exists( $tempdir ) ){
		$old_umask = umask( 0 );
		$result = @mkdir( $tempdir, 0777 );
		umask( $old_umask );
		if( !$result ){
			die( "Could not create temporary directory.\n");
		}
	}
	$tempurl = $conf['baseURL'] . 'data/temp/';
}


/*** Cleanup temp directory ***/

$dh = opendir( $tempdir );
while( ( $file = readdir( $dh ) ) !== false ){
	if( $file != '.' && $file != '..' && is_dir( "$tempdir/$file" ) && filectime( "$tempdir/$file" ) < time() - $ziplifetime ){
		$dh2 = opendir( "$tempdir/$file" );
		while( ( $file2 = readdir( $dh2 ) ) !== false ){
			if( $file2 != '.' && $file2 != '..' ){
				unlink( "$tempdir/$file/$file2" );
			}
		}
		closedir( $dh2 );
		rmdir( "$tempdir/$file" );
	}
}


/*** Build file list ***/

if( !mysql_connect( $conf['mysqlServer'], $conf['mysqlUser'], $conf['mysqlPassword'] ) ){
	die( "Could not connect to mySQL host\n" );
}
if( !mysql_select_db( $conf['mysqlDatabase'] ) ){
	die( "Could not select mySQL database\n" );
}

$files = array();

if( isset($_GET['c']) ){

	$table = $conf['mysqlTablePrefix'] . 'table_downloads';

	$query = "DELETE FROM $table WHERE expires < CURRENT_TIMESTAMP";
	mysql_query( $query );

	$query = "SELECT `path` FROM $table WHERE `code` = '{$_GET['c']}'";
	$result = mysql_query( $query );
	if( $result && mysql_num_rows($result) > 0 ){
		$row = mysql_fetch_array( $result, MYSQL_ASSOC );
		$rawlist = explode( ',', $row['path'] );
		$query = "UPDATE $table SET `download_ip` = '{$_SERVER['REMOTE_ADDR']}', `download_ts` = NOW() WHERE `code` = '{$_GET['c']}'";
		mysql_query( $query );
	} else {
		die( "Unknown code {$_GET['c']}\n" );
	}
	
	foreach( $rawlist as $path ){
		if( $path && file_exists( $pxtc_dir . '/' . $_GET['dir'] . '/' . $path ) ){
			$files[] = escapeshellarg( $path );
		}
	}

} else if( isset($_GET['l']) ){
	
	$table = $conf['mysqlTablePrefix'] . 'data_image';
	$list = decodeNumberList( $_GET['l'] );
	$query = "SELECT verzeichnis, dateiname FROM $table WHERE FIND_IN_SET( vtid, '$list' )";
	$result = mysql_query( $query );
	if( $result && mysql_num_rows($result) > 0 ){
		while( $row = mysql_fetch_array( $result, MYSQL_ASSOC ) ) {
			$path = substr( $row['verzeichnis'], 1 ) . '/' . $row['dateiname'];
			if( file_exists( $pxtc_dir . '/' . $_GET['dir'] . '/' . $path ) ){
				$files[] = escapeshellarg( $path );
			}
		}
	}
}
if( !$files ) {
	die( "Nothing to zip\n" );
}

mysql_close();


/*** Create directory for ZIP file ***/

$old_umask = umask( 0 );
for( $i = 1; $i <= 20; $i++ ) {
	$tempname = md5( microtime() . rand() );
	$zipdir = "$tempdir/$tempname";
	if( mkdir( $zipdir, 0777 ) ){
		break;
	}
}
umask( $old_umask );

if( !file_exists( $zipdir ) ){
	die( "Could not create zip directory.\n");
}


/*** Create the ZIP file ***/

chdir( $pxtc_dir . '/' . $_GET['dir'] );
$cmd .= " -0 $zipdir/$zipfilename " . implode( ' ', $files );
exec( $cmd );

/*** Deliver ZIP file ***/

$url = "{$tempurl}{$tempname}/{$zipfilename}";
header( "Location: $url" );
?>